/*
 * scout-robotd/robotd.h
 *
 * header file for robotd program
 *
 *                             ** COPYRIGHT NOTICE **
 *
 * Copyright (c) 2000, Nomadic Technologies, Inc.
 *
 * The contents of this file is copyrighted by Nomadic Technologies, Inc, and
 * is protected by United States copyright laws. You may make as many copies of
 * the software as deemed necessary for the effective programming of the Nomad
 * series robots provided that all copyright and other proprietary notices are
 * reproduced in their entirety.
 *
 */

#ifndef _ROBOTD_H
#define _ROBOTD_H

#define BUFLEN 1024
#define whitespace " \t\n\r,"


/* command opcodes */
#define TK 11
#define AC 1
#define SP 2
#define PR 3
#define PA 4
#define VM 5
#define MV 43
#define CT 6
#define GS 7
#define NAK 8
#define ST 9
#define LP 10
#define TK 11
#define DP 12
#define ZR 13
#define CONF_IR 14
#define CONF_SN 15
#define CONF_CP 16
#define CONF_LS 17
#define CONF_TM 18
#define GET_IR 19
#define GET_SN 20
#define GET_RC 21
#define GET_RV 22
#define GET_RA 23
#define GET_CP 24
#define GET_LS 25
#define SETUP_LS 26
#define GET_BP 27
#define CONF_SG 28
#define GET_SG 29
#define DA 30
#define WS 31
#define ADD_OBS 32
#define DELETE_OBS 33
#define MOVE_OBS 34
#define INIT_SENSORS 35
#define PLACE_ROBOT 36
#define NUM_COMMANDS 36
#define SPECIAL 128


/* message format */
struct msg_hdr
{
  unsigned char magic;
  unsigned char len0;
  unsigned char len1;
  unsigned char type;
  unsigned char data[0];
};



/* console.c */
int CON_ProcessMsg(int confd, int ttyfd);
void CON_PrintGreeting(int fd);

/* host.c */
int HOST_Forward(int dst, int src);
int HOST_ReadN(int fd, void *buf, size_t count);

/* tk.h */
void TK_Init(const char *command);
int TK_Talk(struct msg_hdr *msg);
int TK_IsTkRequest(char buf[]);

/* variable.c */
extern const char *robd_program_name;


 
#endif /* _ROBOTD_H */
